config/routes.rb
Rails.application.routes.draw do
  resources :strength_trainings
  resources :endurance_trainings
  resources :strength_trainings
  resources :endurance_trainings
  resources :strength_trainings
  resources :strength_trainings
  resources :endurance_trainings
  resources :trainings
  resources :statistic_entries
  resources :training_days
  resources :users

  get 'weekoverview/index'
  post '/weekoverview/index', to: 'weekoverview#index'

  get 'trainings/new/:date', to: 'trainings#new'

  get 'statistic_entries/new/:date', to: 'statistic_entries#new'

  get 'sessions/new'
  get    'help'    => 'static_pages#help'
  get    'about'   => 'static_pages#about'
  get    'contact' => 'static_pages#contact'
  get    'signup'  => 'users#new'
  get    'login'   => 'sessions#new'
  post   'login'   => 'sessions#create'
  delete 'logout'  => 'sessions#destroy'

  root :to => 'sessions#new'

end

app/controllers/weekoverview_controller.rb
class WeekoverviewController < ApplicationController

  include SessionsHelper

  def index
    if request.post?
      # with posted date
      @date = params[:date]
      @array = Array.new(7)
      #@date = Date.today

      # arrayExample
      # [ day => [dayName,date] ,
      #   trainingsDay
      # ]

      p "###################" + @date
      weekArray = calculateWeekDays(@date)
      weekArray.each_with_index do |date, index|
        trainingsDay = TrainingDay.find_by(date: date, user:current_user)
        day = {
            'name' => date.strftime("%A"),
            'date' => date
        }
        @subArray = {
            'day' => day,
            'trainingsDay' => nil
        }
        if trainingsDay.present?
          @subArray['trainingsDay'] = trainingsDay
        end
        @array[index] = @subArray
      end
    else
      @array = Array.new(7)
      p "ooooooooooooooooooooooooooooooooooooooooooooo"
      # arrayExample
      # [ day => [dayName,date] ,
      #   trainingsDay
      # ]
      weekArray = calculateWeekDays(Date.today.to_s)
      weekArray.each_with_index do |date, index|
        trainingsDay = TrainingDay.find_by(date: date, user:current_user)

        day = {
            'name' => date.strftime("%A"),
            'date' => date
        }
        @subArray = {
            'day' => day,
            'trainingsDay' => nil
        }
        if trainingsDay.present?
          @subArray['trainingsDay'] = trainingsDay
        end
        @array[index] = @subArray
      end

      @date =  Date.today
      return @array, @date
    end
  end

  #
  # calculate the weekday from an given date
  # and returns them as an array
  #
  def calculateWeekDays (dateString)

    date = Date.parse(dateString)
    monday = Date.commercial(date.cwyear, date.cweek)
    return result = Array[
        monday,
        monday + 1,
        monday + 2,
        monday + 3,
        monday + 4,
        monday + 5,
        monday + 6
    ]
  end


end

app/helpers/weekoverview_helper.rb
module WeekoverviewHelper
end

app/views/weekoverview/index.html.erb
<%# encoding: utf-8 %>

<%= render 'layouts/header' %>

<meta http-equiv="content-type" content="text/html;charset=UTF-8"/>

<!-- hab mal den kram an bissle standart angepasst -->
<div class="container">

  <h1>Wochenansicht</h1>

  <form class="form-inline" action="/weekoverview/index" accept-charset="UTF-8" method="post" style="margin: 1%">
    <div class="form-group">
      <label class="control-label" for="date">Ansicht zum</label>
      <input type="date" name="date" class="form-control" id="date" placeholder="Ansichtsdatum" min="1990-01-01" max="2250-12-31" value="<%= @date.to_s %>">
      <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
      <button type="submit" class="btn btn-primary">Go</button>
    </div>
  </form>

  <table class="table table-striped table-bordered table-condensed">
    <thead>
    <tr>
      <% @array.each do |data| %>
          <th class="text-center" style="background-color: #f9f9f9">
            <%= data["day"]["name"] %> <br>
            <%= data["day"]["date"].to_s %>
          </th>
      <% end %>
    </tr>
    </thead>

    <tbody>
    <!-- jedes tr ist eine zeile in der table

         ein td sntspricht nach der reihenfolge eine spalte in der table

          so braucht jeder eintrg bei uns 7 tds für 7 tage wenn man alle füllen möchte

          das laern wir dann in schleifen aus und temp blöcke
    -->

    <!-- first row -->
    <tr>
      <% @array.each_with_index do |data, index| %>
          <td class='row'>
            <div class="panel-group">
              <div class="list-group">
                <% if data["trainingsDay"] != nil %>
                    <% data["trainingsDay"].trainings.each do |trainings| %>
                        <% if trainings.type.to_s.eql? 'StrengthTraining' %>
                            <a href='<%= strength_training_path(trainings) %>' class="list-group-item list-group-item-success" style="font-weight: bold">
                              <div>
                                <%= trainings.name %>
                              </div>
                            </a>
                        <% end %>
                        <% if trainings.type.to_s.eql? 'EnduranceTraining' %>
                            <a href='<%= endurance_training_path(trainings) %>' class="list-group-item list-group-item-success" style="font-weight: bold">
                              <div>
                                <%= trainings.name %>
                              </div>
                            </a>
                        <% end %>
                    <% end %>
                <% end %>
                <a href='/trainings/new/<%= @array[index]["day"]["date"].to_s %>' class="list-group-item list-group-item-success" id="new_training_entry<%= index %>">+ New Training</a>
              </div>
              <div class="list-group">
                <% if data["trainingsDay"] != nil %>
                    <% data["trainingsDay"].statistic_entries.each do |statistic_entry| %>
                        <a href='<%= statistic_entry_path(statistic_entry) %>' class="list-group-item list-group-item-info">
                          <div style="display: block">
                            <div  style="float: left; margin: auto; font-weight: bold"><%= statistic_entry.name %></div>
                            <div class="label" style="margin: 5%; color: black"><%= statistic_entry.value %></div>
                          </div>
                        </a>
                    <% end %>
                <% end %>
                <a href='/statistic_entries/new/<%= @array[index]["day"]["date"].to_s %>' class="list-group-item list-group-item-info" id="new_stat_entry<%= index %>">+ New Statistic</a>
              </div>
            </div>
          </td>
      <% end %>
    </tr>
    <!-- second row -->
    </tbody>
    <!--<td>-->
    <!--<div>-->
    <!--<%# @array[0].trainings.each do |trainings| %>-->
    <%#= trainings %>
    <!--<%# end %>-->
    <!--</div>-->
    <!--</td>-->
    <!--</table>-->
  </table>
</div>